/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

class Cable.Irc.Client : GLib.Object {

    /**
     * Names of the servers we are currently connected to.
     */
    public static string[] server_names {
        owned get {
            try {
                return client.servers ();
            } catch (GLib.IOError e) {
                warning (e.message);
            }
            
            return {};
        }
    }
    
    /**
     * All known servers.
     */
    public static string[] known_server_names {
        owned get {
            try {
                return client.server_list ("", "");
            } catch (GLib.IOError e) {
                warning (e.message);
            }
            
            return {};
        }
    }

    /*public static string config_get (string group, string key) throws GLib.IOError {
        return client.config_get (group, key);
    }

    public static void config_set (string group, string key, string value) throws GLib.IOError {
        client.action (group, key, value);
    }*/
}
