/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

/**
 * Namespace for all IRC backend related classes.
 */
namespace Cable.Irc {

    /**
     * Static reference to the maki interface.
     */
    Maki client = null;
    
    public void init () {
        if (client == null) {
            try {
                client = Bus.get_proxy_sync (GLib.BusType.SESSION, "de.ikkoku.sushi", "/de/ikkoku/sushi");
            } catch (GLib.IOError error) {
                warning (error.message);
            }
            
            debug ("Successfully connected to Sushi dbus session.\n");
        }
        
        Server.init ();
    }
}
