/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

/**
 * Static class to deal with notifications.
 */
public class Cable.Services.Notify : GLib.Object {

    public static void init () {
        if (global::Notify.is_initted ()) {
            warning ("Trying to reinitialize Notify.");
            return;
        }

        global::Notify.init ("Cable");
    }

    public static void send (string summary, string body) {
        var notify = new global::Notify.Notification (summary, body, "internet-chat");
        try {
            notify.show ();
        } catch (Error e) {
            warning (e.message);
        }
    }
}
