/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

public class Cable.Utils.AutoScrolled : Gtk.ScrolledWindow {

    public bool autoscroll { get; set; default = true; }

    public AutoScrolled () {
        setup_autoscroll ();
    }

    void setup_autoscroll () {
        var do_scroll = true;
        var adj = get_vadjustment ();

        get_vadjustment ().changed.connect (() => {
            var do_scroll_old = do_scroll;
            do_scroll = adj.value + adj.page_size == adj.upper;

            if (do_scroll_old)
                adj.set_value (adj.upper);
        });

        get_vadjustment ().value_changed.connect (() => {
            do_scroll = adj.value + adj.page_size == adj.upper;
        });
    }
}
