/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

namespace Cable.Utils {

    class Label : Gtk.Label {

        public Label (string text) {
            this.label = text;
            this.halign = Gtk.Align.START;
        }

        public Label.right (string text, bool sensitive = true) {
            this.label = text;
            this.halign = Gtk.Align.END;
            this.valign = Gtk.Align.CENTER;
            this.sensitive = sensitive;
        }
    }

    // FIXME this sucks and only works for normal entries
    public void filter (Gtk.Editable editable, string text, string[] needles) {
        foreach (var needle in needles)
            if (needle in text)
                Signal.stop_emission_by_name (editable, "insert-text");
    }

    public string parse_string_to_markup (string input) {
        var up_marker = new Cable.Utils.UpMarker ();
        return up_marker.mark_up (input);
    }
}
