/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

public interface Cable.View.Chat : GLib.Object {

    public abstract int unread_messages { get; set; }
    public abstract string nick { get; set; }
    public abstract string name { get; set; }
    public abstract string id { get; set; }
    public abstract string entry { get; set; }
    public abstract bool has_focus { get; }
    
    public signal void send_message (string message);
    public signal bool focused ();
    
    public abstract void rename_user (string? old_nick, string new_nick, UserType type, bool silent = false);
    public abstract void set_away_status (string nick, bool is_away);
    public abstract void message (owned string from, string message, MessageType type = MessageType.NORMAL);
}

public interface Cable.View.Channel : GLib.Object, View.Chat {

    public abstract State state { get; set; }
    public abstract string topic { get; set; }

    public signal void join ();
    public signal void part ();
    public signal void send_message (string message);
    public signal bool focused ();
    public signal void private_chat_requested (string name);

    public abstract bool has_user (string nick);
    public abstract void list_users (string[] nicks, string[] prefixes);
    public abstract void add_user (string nick, UserType type, bool silent = false);
    public abstract void remove_user (string nick, string message, bool silent = false);
}

public interface Cable.View.PrivateChat : GLib.Object, View.Chat {

    public signal void send_message (string message);
    public signal bool focused ();
}
