/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

public interface Cable.View.Server : GLib.Object {

    public abstract bool away { set; }
    public abstract string name { get; set; }
    public abstract string id { get; set; }
    
    public abstract Gee.ArrayList <Chat> chats { owned get; }
    
    public string[] chat_ids {
        owned get {
            string[] result = {};
            foreach (var chat in chats)
                result += chat.id;
            return result;
        }
    }
    
    public abstract signal void toggle_away ();
    public abstract signal void part_all ();

    public abstract void add_channel (string chat_name, string chat_id);
    public abstract void add_private_chat (string chat_name, string chat_id);
    public abstract void remove_chat (string chat_id);
    
    public bool has_chat (string chat_id) {
        return chat_id in chat_ids;
    }

    public Chat? get_chat (string chat_id) {
        foreach (var chat in chats)
            if (chat.id == chat_id)
                return chat;

        return (Chat) null;
    }
}
