/***
    Copyright (C) 2013 Cable Developers

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

public class Cable.Widgets.Topic : Gtk.InfoBar {

    /**
     * The actual topic.
     */
    public string topic {
       get { return topic_label.label; }
       set {
            if (value != "") {
                var new_topic = Utils.parse_string_to_markup (value);
                topic_label.set_markup (new_topic);
                topic_label.set_tooltip_text (new_topic);
                no_show_all = false;
                show_all ();
            } else {
                visible = false;
                no_show_all = true;
            }
       }
    }
    
    Gtk.Button arrow_button;
    Gtk.Arrow arrow;
    Gtk.Label topic_label;
    Gtk.Grid grid; 
        
    public Topic () {
        arrow_button = new Gtk.Button ();
        arrow = new Gtk.Arrow (Gtk.ArrowType.RIGHT, Gtk.ShadowType.ETCHED_IN);
        arrow_button.valign = Gtk.Align.START;
        arrow_button.relief = Gtk.ReliefStyle.NONE;
        arrow_button.add (arrow);
        
        topic_label = new Gtk.Label ("");
        topic_label.hexpand = true;
        topic_label.margin_left = 12;
        topic_label.margin_right = 12;
        topic_label.ellipsize = Pango.EllipsizeMode.END;
        topic_label.wrap_mode = Pango.WrapMode.WORD;
        
        grid = new Gtk.Grid ();
        grid.attach (arrow_button, 0, 0, 1, 1);
        grid.attach (topic_label, 1, 0, 1, 1);

        (get_content_area () as Gtk.Container).add (grid);
        no_show_all = true;
        
        arrow_button.clicked.connect (() => {
            topic_label.wrap = !topic_label.wrap;
            arrow.arrow_type = (topic_label.wrap) ? Gtk.ArrowType.DOWN : Gtk.ArrowType.RIGHT;
        });
    }
}
