public class Unit.TestSuite : GLib.Object, Test {

    Gee.List <Test> tests;

    public string name { get; set; }

    public int test_cases {
        get {
            var result = 0;
            foreach (var test in tests)
                result += test.test_cases;
            return result;
        }
    }
    
    public int n_tests {
        get {
            var result = 0;
            foreach (var test in tests)
                result += test.n_tests;
            return result;
        }
    }

    public TestSuite (string name) {
        Object (name: name);
        tests = new Gee.ArrayList <Test> ();
    }

    public void add_test (Test test) {
        tests.add (test);
    }

    public void run () {
        print (format_status (@"[$name]\n"));
        foreach (var test in tests)
            test.run ();
        print (format_status (@"Executed $test_cases test cases with $n_tests unit tests.\n"));
    }
}
